<?php

// Check nonce
PHPCUS_PARAM::CUS_REQUIRES_NONCE();

// Check Array Input
PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();

// Check already authenticated
PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
// Check access rights
PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'addon_license_group');

if
(
    PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
    (
        [
            'PARAM_ADD_GLICENSE_ID',
            'PARAM_ADD_GLICENSE_ACC_GROUP_ID',
            'PARAM_ADD_GLICENSE_DATE_RENEW_FROM',
            'PARAM_ADD_GLICENSE_DATE_RENEW_TO',
            'PARAM_ADD_GLICENSE_DATE_EXPIRY_FROM',
            'PARAM_ADD_GLICENSE_DATE_EXPIRY_TO',
            'PARAM_ADD_GLICENSE_VOLUME_FROM',
            'PARAM_ADD_GLICENSE_VOLUME_TO',
            'PARAM_ADD_GLICENSE_STATUS',
            'PARAM_ADD_GLICENSE_SYSTEM_GENERATED',
            
            'PARAM_ORDER_FIELD',
            'PARAM_ORDER_TYPE',
            'PARAM_SKIP',
            'PARAM_LIMIT'
        ], True
        )
    )
{
    Try
    {
        // Read params
        // ------------------------------------------------------------------
        $PARAM_ADD_GLICENSE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ADD_GLICENSE_ID');
        $PARAM_ADD_GLICENSE_ACC_GROUP_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ADD_GLICENSE_ACC_GROUP_ID');
        $PARAM_ADD_GLICENSE_DATE_RENEW_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_ADD_GLICENSE_DATE_RENEW_FROM');
        $PARAM_ADD_GLICENSE_DATE_RENEW_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_ADD_GLICENSE_DATE_RENEW_TO');
        $PARAM_ADD_GLICENSE_DATE_EXPIRY_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_ADD_GLICENSE_DATE_EXPIRY_FROM');
        $PARAM_ADD_GLICENSE_DATE_EXPIRY_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_ADD_GLICENSE_DATE_EXPIRY_TO');
        $PARAM_ADD_GLICENSE_VOLUME_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ADD_GLICENSE_VOLUME_FROM');
        $PARAM_ADD_GLICENSE_VOLUME_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ADD_GLICENSE_VOLUME_TO');
        $PARAM_ADD_GLICENSE_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_ADD_GLICENSE_STATUS');
        $PARAM_ADD_GLICENSE_SYSTEM_GENERATED = PHPCUS_PARAM::CUS_READ_INT('PARAM_ADD_GLICENSE_SYSTEM_GENERATED');
        
        $PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
        (
            'PARAM_ORDER_FIELD',
            [
                'ADD_GLICENSE_ID',
                'ADD_GLICENSE_ACC_GROUP_ID',
                'ADD_GLICENSE_DATE_RENEW',
                'ADD_GLICENSE_DATE_EXPIRY',
                'ADD_GLICENSE_VOLUME',
                'ADD_GLICENSE_STATUS',
                'ADD_GLICENSE_SYSTEM_GENERATED'
            ]
            );
        $PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
        $PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
        $PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
        
        // ------------------------------------------------------------------
        
        
        // Populate Map Array
        // ...........................................
        $GET_MAP_ARRAY = PHPCUS_ADDON_LICENSE_GROUP::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
        
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_ID'] = $PARAM_ADD_GLICENSE_ID;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_ACC_GROUP_ID'] = $PARAM_ADD_GLICENSE_ACC_GROUP_ID;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_DATE_RENEW_FROM'] = $PARAM_ADD_GLICENSE_DATE_RENEW_FROM;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_DATE_RENEW_TO'] = $PARAM_ADD_GLICENSE_DATE_RENEW_TO;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_DATE_EXPIRY_FROM'] = $PARAM_ADD_GLICENSE_DATE_EXPIRY_FROM;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_DATE_EXPIRY_TO'] = $PARAM_ADD_GLICENSE_DATE_EXPIRY_TO;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_VOLUME_FROM'] = $PARAM_ADD_GLICENSE_VOLUME_FROM;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_VOLUME_TO'] = $PARAM_ADD_GLICENSE_VOLUME_TO;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_STATUS'] = $PARAM_ADD_GLICENSE_STATUS;
        $GET_MAP_ARRAY['PARAM_ADD_GLICENSE_SYSTEM_GENERATED'] = $PARAM_ADD_GLICENSE_SYSTEM_GENERATED;
        
        $GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
        $GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
        $GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
        $GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
        
        
        // Execute Stored Procedure
        // ...........................................
        $DATA_SET = PHPCUS_ADDON_LICENSE_GROUP::CUS_GET_MA($GET_MAP_ARRAY);
        
        
        // Return JSON response
        // ...........................................
        if(empty($DATA_SET) === False)
        {
            PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
        }
        else
        {
            PHPCUS_PARAM::CUS_JSON_SUCCESS('');
        }
        
    }
    Catch(Exception $ERR)
    {
        PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
        PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
    }
}
else
{
    PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
}

?>